# NOTE: this class has been translated from Java.
# Do not modify this file, changes will be overwritten.

#package orbitgt.mapping3d.sdk.viewer;

from .....orbitgt.mapping3d.sdk.viewer.AMap import AMap

#
# Class MapObject defines an object to be displayed on the map.
#
class MapObject:
    # The type of objects in this class */
    TYPE: str = "M"

    # The type of vector map objects (points,lines,areas) */
    TYPE_VECTOR: str = "vector"
    # The type of footprint map objects */
    TYPE_FOOTPRINT: str = "footprint"
    # The type of field-of-view map objects */
    TYPE_FOV: str = "fov"
    # The type of measurement map objects */
    TYPE_MEASUREMENT: str = "measurement"
    # The type of global map objects */
    TYPE_GLOBAL: str = "global"

    # The spatial point */
    #public Coordinate spatialPoint
    # The spatial line */
    #public CoordinatePath spatialLine
    # The spatial area */
    #public CoordinatePath spatialArea

    # The type of map object */
    #public String objectType
    # The identifier of the resource this map object belongs to */
    #public String resourceId
    # The identifier of the map object */
    #public String objectId

    # The point or line color of the map object */
    #public Color color
    # The optional fill color of the map object (in case a spatial area is provided) */
    #public Color fillColor
    # The line width for spatial lines or areas */
    #public double lineWidth

    # The optional symbol name (circle_filled, diamond_filled, square_filled, star_filled or triangle_filled) */
    #public String symbolName
    # The optional symbol size in case a symbol name is given (in screen pixels) */
    #public double symbolSize
    # The optional symbol path (if no symbol name is given) */
    #public CoordinatePath symbolPath

    # The optional label of the map object */
    #public String label
    # The position of the optional label of the map object (in screen pixels and relative to the coordinate center of the spatial point, line or area) */
    #public Coordinate labelPosition
    # The size of the label font */
    #public double labelFontSize
    # The name of the label font */
    #public String labelFontName
    # The color of the label font */
    #public Color labelColor

    #
    # A map of optional object properties.
    # In case of a 'fov' mapobject, the following properties may be available : viewId,renderMode,pan,tilt,fov.
    #
    #public AMap[str] properties

    #
    # Create a new object.
    #
    def __init__(self):
        self.spatialPoint = None
        self.spatialLine = None
        self.spatialArea = None
        self.resourceId = None
        self.objectType = None
        self.objectId = None
        self.label = None
        self.labelPosition = None
        self.labelFontSize = -1
        self.labelFontName = None
        self.labelColor = None
        self.color = None
        self.fillColor = None
        self.lineWidth = -1
        self.symbolName = None
        self.symbolPath = None
        self.symbolSize = -1
        self.properties = None

    #
    # Convert the object to a string.
    # @return the string form of the object.
    #
    def toString(self) -> str:
        return "[MapObject:objectType="+self.objectType+",objectId="+self.objectId+"]"
